<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit"  justify="end">新增</el-button>
    </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="序列号" style="width:2%" align="center">
        <template slot-scope="scope">
          <span>{{scope.row.uid}}</span>
        </template>
      </el-table-column>
      <el-table-column label="类别" style="width:10%" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.depositType== 1">首充</span>
          <span v-if="scope.row.depositType == 2">续充</span>
          <span v-if="scope.row.depositType == 3">全部</span>
        </template>
      </el-table-column>
      <el-table-column label="充值金额" style="width:10%" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.price }}</span>
        </template>
      </el-table-column>
      <el-table-column label="获得金币" style="width:25%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.coins }}</span>
        </template>
      </el-table-column>
      <el-table-column label="促销文案" style="width:2%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.description }}</span>
        </template>
      </el-table-column>
      <!--      <el-table-column label="创建时间" style="width:4%" :show-overflow-tooltip="true" align="center">-->
      <!--        <template slot-scope="scope">-->
      <!--          <span>{{ scope.row.createTime }}</span>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
      <!--      <el-table-column label="更新时间" style="width:4%" :show-overflow-tooltip="true" align="center">-->
      <!--        <template slot-scope="scope">-->
      <!--          <span>{{ scope.row.updateTime }}</span>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
      <el-table-column label="状态" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.status"
                     :inactive-value="0"
                     :active-value="1"
                     active-text="启用"
                     inactive-text="停用"
                     active-color="#13CE66"
                     inactive-color="#FF4949"
                     @change="changeSwitch(scope.row)"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" fixed="right" style="width:8%">
        <template slot-scope="scope" >
          <el-button @click="handleEdit(scope.row)" type="primary" size="small" >编辑</el-button>
          <el-button @click="handleDelete(scope.row)" type="danger" size="small" >删除</el-button>
        </template>
      </el-table-column>

    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :close-on-click-modal="false" :visible.sync="dialogFormVisible" width="30%" :before-close="sortHandleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="充值金额" :label-width="formLabelWidth" prop="price">
          <el-input v-model="form.price" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="获得金币" :label-width="formLabelWidth" prop="coins">
          <el-input v-model="form.coins" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="促销文案" :label-width="formLabelWidth" prop="description">
          <el-input v-model="form.description" style="width:80%" maxlength="10" show-word-limit></el-input>
        </el-form-item>
        <el-form-item label="类别" :label-width="formLabelWidth" prop="depositType">
          <input type="radio" v-model="form.depositType" value="1">&nbsp; 首充 &nbsp;
          <input type="radio" v-model="form.depositType" value="2">&nbsp; 续充 &nbsp;
          <input type="radio" v-model="form.depositType" value="3">&nbsp; 全部 &nbsp;
        </el-form-item>
        <el-form-item label="状态" :label-width="formLabelWidth" prop="status">
          <input type="radio" v-model="form.status" value="0">&nbsp; 停用 &nbsp;
          <input type="radio" v-model="form.status" value="1">&nbsp; 使用中(默认) &nbsp;
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
    import {getDepositConfigList,addDepositConfig,editDepositConfig,deleteDepConfig} from "@/api/depositManager";
    export default {
        created() {
            this.getDepositManagerList();
        },
        data() {
            return {
                tableData: [],
                form: {
                    price: null,
                    coins: null,
                    description: null,
                    depositType: null,
                    status: null,
                },
                queryParams:{
                },
                title: null,
                isChange: false, // 表单内容是否改变
                changeCount: 0, // 改变计数器
                pictureUids: [], //图片uid集合
                resourceData: [], //标签数据
                tagValue: [], //保存选中标签id(编辑时)
                projectValue: null, //保存选中标签id(编辑时)
                tagData: [], //标签数据
                tagOptions: [], //标签候选框
                projectUid: null, //项目uid
                projectName: "全部", //项目名称
                projectOptions: [], //标签候选框
                multipleSelection: [], //多选，用于批量修改标签
                currentPage: 1,
                total: null,
                pageSize: 40,
                orderByDescColumn: "", // 降序字段
                orderByAscColumn: "", // 升序字段
                formLabelWidth: "120px", //弹框的label边框
                dialogFormVisible: false,
                atlasFormVisible: false,
                pictureFormVisible: false,
                atlasDialogPictureVisible: false,//当前分类图集列表
                isSortAdd: false,
                isEditForm: false,
                photoList: [],
                allProject:[],
                yesNoDictList: [], // 是否字典
                imagecropperKey: 0,
                imagecropperShow: false, //控制图片选择器的显示
                fileIds: "",
                icon: false, //控制删除图标的显示
                isFirstPhotoVisible: true, // 图片选择器是否首次显示【用于懒加载】
                rules: {
                    coins: [
                        {required: true, message: '获取金币不能为空', trigger: 'blur'},
                        {pattern: /^[0-9]\d*$/, message: '获取金币只能为自然数'},
                    ],
                    price: [
                        {required: true, message: '充值金额不能为空', trigger: 'blur'},
                        {pattern: /^[0-9]\d*$/, message: '充值金额只能为自然数'},
                    ],
                    depositType: [
                      {required: true, message: '充值类别不能为空', trigger: 'blur'}
                    ],
                    status: [
                        {required: true, message: '状态不能为空', trigger: 'blur'}
                    ],
                    description: [
                        {required: true, message: '促销文案不能为空', trigger: 'blur'}
                    ]
                }
            };
        },

        methods: {
            getDepositManagerList: function() {
                this.queryParams.currentPage = this.currentPage;
                this.queryParams.pageSize = this.pageSize;
                this.queryParams.orderByDescColumn = this.orderByDescColumn
                this.queryParams.orderByAscColumn = this.orderByAscColumn
                getDepositConfigList(this.queryParams).then(response => {
                    this.tableData = response.data.records;
                    this.currentPage = response.data.current;
                    this.pageSize = response.data.size;
                    this.total = response.data.total;
                });
            },
            changeSwitch: function(data){
                editDepositConfig(data).then(response => {
                    this.$commonUtil.message.success(response.message)
                    this.dialogFormVisible = false;
                    this.getDepositManagerList();
                });
            },
            //点击单选
            checked: function(data) {
                let idIndex = this.pictureUids.indexOf(data.uid);
                if (idIndex >= 0) {
                    //选过了
                    this.pictureUids.splice(idIndex, 1);
                } else {
                    this.pictureUids.push(data.uid);
                }
            },

            handleFind: function() {
                this.currentPage = 1
                this.getDepositManagerList();
            },
            getFormObject: function() {
                var formObject = {
                    price: null,
                    coins: null,
                    description: null,
                    depositType: null,
                    status: 1,

                };
                return formObject;
            },
            /**
             * 翻页事件
             */
            handleSizeChange(val) {
                this.pageSize = val;
                this.getDepositManagerList();
            },
            //改变页码
            handleCurrentChange(val) {
                this.currentPage = val;
                this.getDepositManagerList();
            },

            //点击新增
            handleAdd: function() {
                this.title = "新增充值设置"
                this.isSortAdd = true
                this.dialogFormVisible = true;
                this.form = this.getFormObject();
                this.isEditForm = false;
            },
            //点击编辑
            handleEdit: function(row) {
                this.title = "编辑充值设置"
                this.isSortAdd = false;
                this.dialogFormVisible = true;
                this.isEditForm = true;
                this.form = row;
                // this.form.price = row.project.price;
                // this.form.coins = row.project.coins;
                // this.form.sort = row.project.sort;
            },
            sortHandleClose(){
                this.dialogFormVisible = false;
                this.$refs.form.clearValidate();
                this.getDepositManagerList();
            },

            showPicture: function(url) {
                this.atlasDialogPictureVisible = true
                this.atlasDialogImageUrl = url
            },

          handleDelete: function(row) {
            this.$confirm("此操作将把该充值设置删除, 是否继续?", "提示", {
              confirmButtonText: "确定",
              cancelButtonText: "取消",
              type: "warning"
            })
              .then(() => {
                let params = {}
                params.uid = row.uid
                deleteDepConfig(params).then(response=> {
                  this.$commonUtil.message.success(response.message)
                  this.getDepositManagerList();
                })
              })
              .catch(() => {
                this.$commonUtil.info("已取消删除")
              });
          },

            submitForm: function() {
                this.$refs.form.validate((valid) => {
                    if(!valid) {
                        console.log("校验出错")
                    } else {
                        if (this.isEditForm) {
                            editDepositConfig(this.form).then(response => {
                                this.$commonUtil.message.success(response.message)
                                this.dialogFormVisible = false;
                                this.getDepositManagerList();
                            });
                        } else {
                            addDepositConfig(this.form).then(response => {
                                if (response.code == this.$ECode.SUCCESS) {
                                    this.$commonUtil.message.success(response.message)
                                } else {
                                    this.$commonUtil.message.error(response.message)
                                }
                                this.dialogFormVisible = false;
                                this.getDepositManagerList();
                            });
                        }
                    }
                })
            },


        }
    }
</script>

<style scoped>

</style>
